/**
 * DESCRIPTION OF THE FILE
 *
 * @author Michal Kravčenko
 * @date 14.6.18 -
 */

#ifndef INC_4NEURO_CONNECTIONWEIGHT_H
#define INC_4NEURO_CONNECTIONWEIGHT_H

#include <functional>
#include <vector>

class ConnectionFunctionGeneral {
protected:

    /**
     *
     */
    std::vector<size_t> param_indices;

public:

    /**
     *
     */
    ConnectionFunctionGeneral();

    /**
     *
     * @param param_count
     * @param f
     */
    ConnectionFunctionGeneral(std::vector<size_t> &param_indices, std::string &function_string);

    /**
     *
     */
    virtual ~ConnectionFunctionGeneral( );


    /**
     *
     * @return
     */
    virtual double eval( std::vector<double> &parameter_space );

    /**
     * Performs partial derivative of this transfer function according to all parameters. Adds the values multiplied
     * by alpha to the corresponding gradient vector
     */
    virtual void eval_partial_derivative( std::vector<double> &parameter_space, std::vector<double> &weight_gradient, double alpha );


};


#endif //INC_4NEURO_CONNECTIONWEIGHT_H
